﻿Object subclass: #Animal
	instanceVariableNames: 'name intelligence habitat '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animal Application'!
!Animal commentStamp: '<historical>' prior: 0!
Animal:
	{abstract}
	defining attributes and behavior of animal
!


!Animal methodsFor: 'initialization' stamp: 'mu 5/25/2004 23:30'!
init
	name _ ''.
	intelligence _ 0.
	habitat _ ''.! !


!Animal methodsFor: 'accessing'!
habitat
	^habitat! !

!Animal methodsFor: 'accessing' stamp: 'mu 5/25/2004 23:30'!
habitat: aString
	habitat _ aString! !

!Animal methodsFor: 'accessing'!
intelligence
	^intelligence! !

!Animal methodsFor: 'accessing' stamp: 'mu 5/25/2004 23:30'!
intelligence: anInteger
	intelligence _ anInteger! !

!Animal methodsFor: 'accessing'!
name
	^name! !

!Animal methodsFor: 'accessing' stamp: 'mu 5/25/2004 23:30'!
name: aString
	name _ aString! !


!Animal methodsFor: 'actions' stamp: 'mu 5/25/2004 23:27'!
talk
	self display: '...(話せません)...'!]lang[(26 5 5)0,5,0! !


!Animal methodsFor: 'private' stamp: 'mu 5/25/2004 23:25'!
display: aString
	Transcript cr; show: (self class name, ' の ', self name, ' は ', aString).!]lang[(60 1 17 1 13)0,5,0,5,0! !


Animal subclass: #Bird
	instanceVariableNames: 'canFly '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animal Application'!
!Bird commentStamp: '<historical>' prior: 0!
Bird:
	{abstract}

Instance Variables:
	canFly	<Boolean>	

!


!Bird methodsFor: 'initialization' stamp: 'mu 5/25/2004 23:30'!
init
	super init.
	habitat _ '空'.
	canFly _ true!]lang[(32 1 18)0,5,0! !


!Bird methodsFor: 'actions' stamp: 'mu 8/18/2004 23:26'!
fly
	canFly ifTrue:[
		self display: '*** 飛んでます ***'
	]!]lang[(44 5 9)0,5,0! !


!Bird methodsFor: 'accessing'!
canFly
	^canFly! !

!Bird methodsFor: 'accessing' stamp: 'mu 5/25/2004 23:30'!
canFly: aBoolean
	canFly _ aBoolean! !


Bird subclass: #Parrot
	instanceVariableNames: 'vocabulary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animal Application'!
!Parrot commentStamp: '<historical>' prior: 0!
Parrot:

Instance Variables:
	vocabulary	<String>	

!


!Parrot methodsFor: 'initialization' stamp: 'mu 5/25/2004 23:55'!
init
	super init.
	intelligence _ 30.
	habitat _ '鳥かご'.
	vocabulary _ ''!]lang[(50 3 19)0,5,0! !


!Parrot methodsFor: 'accessing'!
vocabulary
	^vocabulary! !

!Parrot methodsFor: 'accessing' stamp: 'mu 5/25/2004 23:30'!
vocabulary: aString
	vocabulary _ aString! !


!Parrot methodsFor: 'actions'!
talk
	vocabulary = ''
		ifTrue: [super talk]
		ifFalse: [self display: vocabulary]! !


Bird subclass: #Swallow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animal Application'!
!Swallow commentStamp: '<historical>' prior: 0!
Swallow:!


!Swallow methodsFor: 'initialization' stamp: 'mu 5/25/2004 23:29'!
init
	super init.
	intelligence _ 25.
! !
