﻿Object subclass: #Haiku
	instanceVariableNames: 'upperFive middleSeven lowerFive '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Haiku Application'!

!Haiku methodsFor: 'actions' stamp: 'mu 3/12/2015 15:40'!
composeAtRandom
	self upperFive: self class defaultUpperFives atRandom.
	self middleSeven: self class defaultMiddleSevens atRandom.
	self lowerFive: self class defaultLowerFives atRandom.
! !


!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:39'!
lowerFive
	^lowerFive! !

!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:41'!
lowerFive: aString
	lowerFive _ aString! !

!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:39'!
middleSeven
	^middleSeven! !

!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:42'!
middleSeven: aString
	middleSeven _ aString! !

!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:39'!
upperFive
	^upperFive! !

!Haiku methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:42'!
upperFive: aString
	upperFive _ aString! !


!Haiku methodsFor: 'printing' stamp: 'mu 3/12/2015 15:53'!
printOn: aStream 
	aStream nextPutAll: self upperFive;
		 nextPutAll: self middleSeven;
		 nextPutAll: self lowerFive
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Haiku class
	instanceVariableNames: ''!

!Haiku class methodsFor: 'instance creation' stamp: 'mu 3/12/2015 15:41'!
random
	"Haiku random"
	| inst |
	inst _ self new.
	inst composeAtRandom.
	^inst
! !


!Haiku class methodsFor: 'defaults' stamp: 'mu 3/12/2015 15:34'!
defaultLowerFives  
	^#('俺の夏' '仁王立ち' 'お姉さん' '高笑い' 'のぼり竜' '夢の後' '山ごもり' '引っ越しか').
!]lang[(25 3 3 4 3 4 3 3 3 4 3 3 3 4 3 5 4)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !

!Haiku class methodsFor: 'defaults' stamp: 'mu 3/12/2015 15:52'!
defaultMiddleSevens 
	^#('そこのけそこのけ' '明日は我が身か' 'えらくなったな' 'みぎもひだりも' '料理作って' '牛乳一本').
!]lang[(26 8 3 7 3 7 3 7 3 5 3 4 4)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!Haiku class methodsFor: 'defaults' stamp: 'mu 3/12/2015 15:58'!
defaultUpperFives
	^#('古池や' '夕暮れに' 'こどもたち' '父上よ' '寄せる波' 'つまみ食い' 'ドラゴンも').
!]lang[(23 3 3 4 3 5 3 3 3 4 3 5 3 5 4)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !


Object subclass: #Kajin
	instanceVariableNames: 'name works '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Haiku Application'!

!Kajin methodsFor: 'initialization' stamp: 'mu 3/12/2015 15:38'!
initialize
	name _ ''.
	works _ OrderedCollection new
! !


!Kajin methodsFor: 'actions' stamp: 'mu 3/12/2004 16:33'!
composeAsking: HaikuOrTanka
	| work |
	work _ HaikuOrTanka random.
	(PopUpMenu confirm: work)
		ifTrue: [ self works add: work]
! !

!Kajin methodsFor: 'actions' stamp: 'mu 3/12/2004 16:33'!
composeHaiku
	self works add: Haiku random
! !

!Kajin methodsFor: 'actions' stamp: 'mu 3/12/2004 16:33'!
composeTanka
	self works add: Tanka random! !

!Kajin methodsFor: 'actions' stamp: 'mu 3/12/2004 16:33'!
forgetAll
	self works: OrderedCollection new
! !

!Kajin methodsFor: 'actions' stamp: 'mu 3/12/2015 15:45'!
writeWorks
	^self writeWorksSatisfying: [:each | true ] to: self defaultFileName
! !

!Kajin methodsFor: 'actions' stamp: 'mu 8/25/2004 00:59'!
writeWorksSatisfying: block to: fileName 
	| fileStream |
	[fileStream _ FileStream newFileNamed: fileName.
	(self works select: block)
		do: [:each | fileStream nextPutAll: each asString; cr]]
	  ensure: [fileStream ifNotNil: [fileStream close]]! !


!Kajin methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:29'!
name
	^name! !

!Kajin methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:29'!
name: aString
	name _ aString! !

!Kajin methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:29'!
works
	^works! !

!Kajin methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:30'!
works: anOrderedCollection
	works _ anOrderedCollection! !


!Kajin methodsFor: 'private' stamp: 'mu 3/12/2015 15:43'!
defaultFileName
	^name, '(', Date today printString, ').txt'
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Kajin class
	instanceVariableNames: ''!

!Kajin class methodsFor: 'instance creation' stamp: 'mu 3/12/2015 15:29'!
named: aString
	^self new name: aString
! !


!Kajin class methodsFor: 'examples' stamp: 'mu 3/12/2015 15:40'!
example1
	"Kajin example1"
	| kajin |
	kajin _ Kajin named: 'ume'.
	5 timesRepeat: [kajin composeHaiku].
	5 timesRepeat: [kajin composeTanka].
	kajin writeWorks.
	kajin inspect
! !

!Kajin class methodsFor: 'examples' stamp: 'mu 5/27/2004 02:01'!
example2
	"Kajin example2"
	| kajin |
	kajin _ Kajin named: 'ume'.
	5 timesRepeat: [kajin composeHaiku].
	kajin works do: [:each | Transcript cr; show: each].
	kajin forgetAll.
	Transcript cr; show: '===全部忘れたので作ります==='.
	3 timesRepeat: [kajin composeAsking: {Haiku. Tanka} atRandom].
	kajin works do: [:each | Transcript cr; show: each].
	kajin inspect
!]lang[(203 11 139)0,5,0! !

!Kajin class methodsFor: 'examples' stamp: 'mu 3/12/2015 15:50'!
example3
	"Kajin example3"
	| kajin |
	kajin _ Kajin named: 'ume'.
	50 timesRepeat: [kajin composeHaiku].
	kajin
	   writeWorksSatisfying: [:each | '*山ごもり' match: each asString]
	   to: 'Yamagomori.txt'.
	kajin inspect

!]lang[(150 4 66)0,5,0! !


Haiku subclass: #Tanka
	instanceVariableNames: 'firstSeven lastSeven '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Haiku Application'!

!Tanka methodsFor: 'actions' stamp: 'mu 3/12/2015 15:20'!
composeAtRandom
	super composeAtRandom.
	self firstSeven: self class defaultFirstSevens atRandom.
	self lastSeven: self class defaultLastSevens atRandom.
! !


!Tanka methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:07'!
firstSeven
	^firstSeven! !

!Tanka methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:19'!
firstSeven: aString
	firstSeven _ aString! !

!Tanka methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:08'!
lastSeven
	^lastSeven! !

!Tanka methodsFor: 'accessing' stamp: 'mu 3/12/2015 15:19'!
lastSeven: aString
	lastSeven _ aString! !


!Tanka methodsFor: 'printing' stamp: 'mu 3/12/2015 15:20'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: self firstSeven;
		 nextPutAll: self lastSeven.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Tanka class
	instanceVariableNames: ''!

!Tanka class methodsFor: 'defaults' stamp: 'mu 3/12/2015 15:24'!
defaultFirstSevens
	^#('くわばらくわばら' '最果ての地へ' '東名高速' '料理作って' 'アランケイとは' '夏の終わりに').
!]lang[(24 8 3 6 3 4 3 5 3 7 3 6 4)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!Tanka class methodsFor: 'defaults' stamp: 'mu 3/12/2015 15:33'!
defaultLastSevens
	^#('くわばらくわばら' 'ただの思い出' '片腹痛し' 'さまよいながら' '身じろぎもせず' 'ただ駆けめぐる').
!]lang[(23 8 3 6 3 4 3 7 3 7 3 7 4)0,5,0,5,0,5,0,5,0,5,0,5,0! !
