﻿"Stream"

"ReadStream"
readStream _ ReadStream on: #(1 2 3 4). 
Transcript cr; show: readStream next.
Transcript space; show: readStream next.
Transcript space; show: readStream next.
Transcript space; show: readStream next.
Transcript space; show: readStream next.

"whileFalse:との組み合わせ"
readStream _ ReadStream on: #(1 2 3 4). 
[readStream atEnd] whileFalse: [Transcript space; show: readStream next].

"readStream"
readStream _ 'Stream is like a tape recorder' readStream.
[readStream atEnd] whileFalse: [Transcript space; show: readStream next].

"next:"
readStream _ 'Stream is like a tape recorder' readStream.
[readStream atEnd] 
       whileFalse: [Transcript cr; show: (readStream next: (#(1 2 3) atRandom))].

"upToEnd"
readStream _ 'Stream is like a tape recorder' readStream.
Transcript cr; show: readStream next.
Transcript cr; show: readStream upToEnd.

"contents"
readStream _ 'Stream is like a tape storage' readStream.
Transcript cr; show: readStream next.
Transcript cr; show: readStream contents.

"position, position:"
readStream _ 'Smalltalk is a simple but powerful language' readStream.
readStream position: 15.	"15番目に飛ぶ"
Transcript cr; show: (readStream next: 6).	"6文字取り出す"
readStream position: 0.	"先頭に戻る"
Transcript cr; show: (readStream next: 9).	"9文字取り出す"
Transcript cr; show: 'Now I''m at ', readStream position asString.

"skip:"
readStream _ 'Smalltalk is a simple but powerful language' readStream.
readStream position: 5.
readStream skip: 10.	"10文字とばす"
Transcript cr; show: (readStream next: 6).
readStream skip: (readStream position negated).	"先頭にもどす(skip:-21)"
Transcript cr; show: (readStream next: 9).
Transcript cr; show: 'Now I''m at ', readStream position asString.

readStream _ 'Smalltalk is a simple but wonderful language' readStream.
readStream skipTo: $w; skip: -1.
Transcript cr; show: (readStream upTo: Character space).

"peek"
readStream _ 'Smalltalk is simple. Squeak has so many useful classes.' readStream.
words _ OrderedCollection new.
[readStream atEnd] whileFalse: [| peekChar |
 readStream peek asLowercase = $s "先頭が$sの場合は"
    ifTrue: [words add: (readStream upTo: Character space)] "wordsに格納"
    ifFalse: [readStream skipTo: Character space]. "違う場合は単語をとばす"
].
words.

"WriteStream".
writeStream _ WriteStream on: #(1 2).
writeStream nextPut: #one.
writeStream nextPut: #two.
writeStream nextPut: Time now.
writeStream contents.

"with:"
writeStream _ WriteStream with: #(1 2).
writeStream nextPut: #three.
writeStream nextPut: #four.
writeStream nextPut: Time now.
writeStream contents.

"nextPutAll:"
writeStream _ WriteStream with: #(1 2).
writeStream nextPutAll: {#three. #four. Time now}.
writeStream contents.

"nextPut:"
writeStream _ WriteStream with: 'Do you like Smalltalk?'.
writeStream nextPut: Character cr.
writeStream nextPut: $Y; nextPut: $e; nextPut: $s.
writeStream nextPut: Character cr.
writeStream nextPutAll: 'Of course!'.
writeStream contents.

"ストリームの速さ測定(1)"
[
100 timesRepeat: [
 writeStream _ WriteStream on: ''. "空の文字列をもとにWriteStreamを生成"
 bigString _ String new: 200000 withAll: $?. "全部?の文字列を生成"
 writeStream nextPutAll: bigString.	"まとめて追加"
].
] timeToRun.

"ストリームの速さ測定(2)"
[
100 timesRepeat: [
 writeStream _ WriteStream on: (String new: 200000).
 bigString _ String new: 200000 withAll: $?.
 writeStream nextPutAll: bigString.
].
] timeToRun.

"ReadWriteStream"
readWriteStream _ ReadWriteStream on: ''.
readWriteStream nextPutAll: 
       'ReadWriteStream can understand #next and #nextPut:'.	"書き込んで"
Transcript cr; show: readWriteStream contents.	"中身を表示"
readWriteStream reset.	"位置をリセット"
[readWriteStream atEnd ] whileFalse: [ | nextChar |
 nextChar _ readWriteStream next.		"一文字読んで"
 (readWriteStream nextPut: nextChar).	"次の文字をnextCharにする"
].
Transcript cr; show: readWriteStream contents.

"ReadStreamとWriteStreamを使った場合"
readStream _ ReadStream on: 
       'ReadWriteStream can understand #next and #nextPut:'.
Transcript cr; show: readStream contents.
writeStream _ WriteStream on: ''.
[readStream atEnd ] whileFalse: [ | nextChar |
 nextChar _ readStream next.
 readStream next.
 writeStream nextPut: nextChar.
 writeStream nextPut: nextChar.
].
Transcript cr; show: writeStream contents.


"FileStream"

"テキストモードの書き込み"
fileStream _ FileStream newFileNamed: 'myData.txt'.
       "新しいファイル名でストリームを作成"
fileStream nextPutAll: 'テキストファイル'.	"書き込み"
fileStream close.	"ストリームを閉じる"

"読み込み"
fileStream _ FileStream readOnlyFileNamed: 'myData.txt'.
		"読み込み用のファイルストリームを作成"
Transcript cr.
[fileStream atEnd] whileFalse: [
       Transcript show: fileStream next; space.
].	"トランスクリプトに一文字ずつスペースを空けて書き出す"
fileStream close.

"読み書き"
fileStream _ FileStream fileNamed: 'myData.txt'.
Transcript cr.
[fileStream atEnd] whileFalse: [
       Transcript show: fileStream next; space.
].	"読み込んでトランスクリプトに表示"
fileStream nextPut: $?.	"$?をストリームの最後に追加"
fileStream close.

"バイナリファイル"
fileStream _ FileStream newFileNamed: 'myData2.bin'.
fileStream binary.		"バイナリモードに切り替える"
fileStream nextPutAll: #(98 121 116 101 115) asByteArray.	"ByteArrayの書き込み"
0 to: 255 do: [:idx |
       fileStream nextPut: idx.	"0-255までの数の書き込み"
].
fileStream close.

"CrLfFileStream"
fileStream _ CrLfFileStream fileNamed: (FileStream fullName: 'myData.txt').
line _ fileStream upTo: Character cr.	"一行読み込む"
line inspect.

"RWBinaryOrTextStream"
writeStream _ RWBinaryOrTextStream on: (String new: 20).
					"文字列をもとに作成"
writeStream nextPutAll: 'This is a string'.
writeStream nextPutAll: #(34 35 36) asByteArray.
writeStream contents.

"TranscriptStream"
Transcript nextPut: Character cr.
Transcript nextPutAll: 'Transcript は TranscriptStream の唯一のインスタンス.'.
Transcript endEntry.

"DataStream"
dataStream _ DataStream fileNamed: 'objects.bin'.
dataStream nextPut: Date today.
dataStream nextPut: Time now.
dataStream close.

dataStream _ DataStream fileNamed: 'objects.bin'.
[dataStream atEnd] whileFalse:[
	dataStream next inspect.
].
dataStream close.

bytes _ DataStream streamedRepresentationOf: (Time now).
object _ DataStream unStream: bytes.
object inspect.


"ReferenceStream"
dict _ Dictionary new.
dict at: #circular put: dict.	"自身の中に自身を登録"
bytes _ ReferenceStream streamedRepresentationOf: dict.
object _ ReferenceStream unStream: bytes.
object inspect.

"ensure:"
answer _ 1.
[ answer _ answer / 0] ensure: [ Transcript cr; show: answer].

