﻿Morph subclass: #MoleHoleMorph
	instanceVariableNames: 'isGameOver score miss stepTime '
	classVariableNames: 'MoleForms '
	poolDictionaries: ''
	category: 'Mole Attack'!

!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 18:35'!
initLayout
	| frame |
	self extent: 74 @ 74.	"大きさの設定"
	self changeProportionalLayout. "プロポーショナル・レイアウトにする"
	frame _ LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (2 @ 2 corner: -2 @ -2).
	
	"サブモーフの追加"
	MoleForms
		keysAndValuesDo: [:key :form | 
			| morph | 
			morph _ SketchMorph withForm: form.
			morph name: key.	"名前をつけておく"
			self addMorph: morph fullFrame: frame]!]lang[(46 6 35 17 102 8 121 8 43)0,5,0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 17:45'!
initialize
	super initialize.
	isGameOver _ false.
	score _ 0.
	miss _ 0.
	stepTime _ 500.
	self initLayout. "レイアウトの初期化"
	!]lang[(110 9 3)0,5,0! !

!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 17:50'!
openInWorld
	MoleForms isEmpty
		ifTrue: [^PopUpMenu inform: '画像を取り込んでください'].
	super openInWorld
!]lang[(62 12 23)0,5,0! !


!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 6/3/2004 17:48'!
step
	| sketch |
	self isGameOver ifTrue: [^self]. "ゲームオーバーであれば何もしないで抜ける"
	sketch _ self submorphs atRandom.
	self addMorph: sketch.
	self color: Color blue.	"通常は青色にしておく"!]lang[(52 20 87 10 1)0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 3/16/2004 23:07'!
stepTime
	^stepTime! !

!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 4/1/2004 19:20'!
stepTime: milliSeconds
	stepTime _ milliSeconds max: 0.
	! !


!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
isGameOver
	^isGameOver! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
isGameOver: aBoolean
	isGameOver _ aBoolean! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
miss
	^miss! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
miss: anInteger
	miss _ anInteger! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:27'!
score
	^score! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:28'!
score: anInteger
	score _ anInteger! !


!MoleHoleMorph methodsFor: 'event handling' stamp: 'mu 4/1/2004 19:29'!
handlesMouseDown: evt
	^ self isGameOver not.! !

!MoleHoleMorph methodsFor: 'event handling' stamp: 'mu 4/2/2004 23:08'!
mouseDown: evt 
	self firstSubmorph knownName = 'Mole'
		ifTrue: [self hit]
		ifFalse: [self failed].
	! !


!MoleHoleMorph methodsFor: 'private' stamp: 'mu 8/29/2004 00:32'!
failed
	self color: Color yellow.	"色を黄色に"
	self playSound: 'warble'. 	"はずれたときの音を鳴らす"
	self score: self score - 5.	"スコアを5点減点"
	self miss: self miss + 1.	"ミスの回数を追加"

	"5回よりもミスが多ければゲームオーバー"
	self miss > 5
		ifTrue: [self isGameOver: true.
			PopUpMenu inform: self score asString]
!]lang[(35 5 31 12 32 4 1 3 30 8 6 18 93)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'private' stamp: 'mu 6/3/2004 17:49'!
hit
	self color: Color red.		"色を赤に"
	self playSound: 'chirp'.	"当たったときの音を鳴らす"
	self stepTime: self stepTime - 50.	"間隔を50ミリ秒減らす"
	self score: self score + 10.	"スコアを10点追加"
!]lang[(30 4 29 12 39 3 2 6 33 4 2 3 2)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'private' stamp: 'mu 4/2/2004 23:37'!
playSound: soundName 
	(SampledSound soundNamed: soundName) play.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MoleHoleMorph class
	instanceVariableNames: ''!

!MoleHoleMorph class methodsFor: 'class initialization' stamp: 'mu 4/2/2004 02:25'!
initialize
	"MoleHoleMorph initialize"
	MoleForms _ IdentityDictionary new.
	! !

!MoleHoleMorph class methodsFor: 'class initialization' stamp: 'mu 4/2/2004 02:07'!
registerAllForms
	"MoleHoleMorph registerAllForms"
	#(#Hole #HalfMole #Mole )
		do: [:each | self registerAt: each fromFileNamed: each , '.png']! !


!MoleHoleMorph class methodsFor: 'accessing' stamp: 'mu 4/2/2004 01:44'!
moleForms
	^MoleForms! !


!MoleHoleMorph class methodsFor: 'utilities' stamp: 'mu 4/3/2004 00:33'!
registerAt: aSymbol fromFileNamed: fineName
	"MoleHoleMorph registerAt: #Hole fromFileNamed: 'Hole.png'"

	| form |
	form _ ImageReadWriter formFromFileNamed: fineName.
	MoleForms at: aSymbol put: form! !

MoleHoleMorph initialize!