﻿"SharedQueue(2)"

queue _ SharedQueue new.

"流し込むためのデータを用意"
data1 _ (Array new: 1000 withAll: 'EAT').
data2 _ (Array new: 1000 withAll: 'SLEEP').

results _ OrderedCollection new.	"読み取り結果の格納用"

"1-3ミリ秒ごとに'EAT'文字列を書き込むプロセスをfork"
writer1 _ [data1 do: [:eachA |  (Delay forMilliseconds: 3 atRandom) wait.
			queue nextPut: eachA]] fork.

"1-5ミリ秒ごとに'SLEEP'文字列を書き込むプロセスをfork"
writer2 _ [data2 do: [:eachB |  (Delay forMilliseconds: 5 atRandom) wait.
			queue nextPut: eachB]] fork.

"キューを読み取り、resultsに格納していくプロセスをfork。
nilが取り出されたら終了する"
reader _ [ | next |
		[(next _ queue next) isNil]
			whileFalse: [results add: next]] fork.

"10秒後に起きて、キューにnilを入れ、結果をインスペクトするプロセスをfork"
stopper _ [Cursor execute 
		showWhile: [(Delay forSeconds: 10) wait. 
			  queue nextPut: nil. 
			  results inspect]] fork.


